<template lang="pug">
.burger( @click='handleClick' :class='{ "active": active }' )
	span 
	span 
	span 
</template>

<script>
export default {
	props: {
		value: {
			type: Boolean,
			default: false
		}
	},
	data() {
		return {
			active: this.value
		}
	},
	watch: {
		value(val) {
			this.active = val
			
			let action = this.active ? "add" : "remove"
			this.root.classList[action]("is-clipped")
		}
	},
	methods: {
		handleClick() {
			this.active = !this.active
			this.$emit("input", this.active)
		}
	}
}
</script>

<style lang="scss" scoped>
$burger: 2rem;
.burger {
	width: $burger;
	height: $burger;
	margin-right: 1rem;
	position: relative;
	user-select: none;
	cursor: pointer;
	* {
		pointer-events: none;
		user-select: none;
	}	
	span {
		display: block;
		height: 2px;
		width: 1rem;
		margin: auto;
		background: #fff;
		border-radius: 15px;
		position: absolute;
		top: 0;
		right: 0;
		bottom: 0;
		left: 0;
		transition: all .2s ease-in-out;
		&:first-of-type {
			bottom: 9px;
		}
		&:last-of-type {
			top: 9px;
		}
	}

	&.active {
		span {
			background: $grey;
			&:first-of-type {
				transform: translateY(4px) rotate(45deg);
			}
			&:nth-of-type(2) {
				transform: translateY(-1px) rotate(-45deg);
			}
			&:last-of-type {
				transform: translateY(-10px);
				opacity: 0;
			}
		}
	}
}
</style>